package me.wazup.hideandseek.utils;

import java.util.regex.Matcher;
import me.wazup.hideandseek.HideAndSeek;
import org.bukkit.inventory.Inventory;
import me.wazup.hideandseek.Config;
import org.bukkit.Sound;
import java.util.Optional;
import org.bukkit.enchantments.Enchantment;
import org.bukkit.potion.PotionType;
import me.wazup.hideandseek.xseries.XMaterial;
import org.bukkit.inventory.ItemStack;
import org.bukkit.Location;
import java.util.Iterator;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Collection;
import org.bukkit.World;
import org.bukkit.Bukkit;
import com.google.common.collect.Lists;
import org.bukkit.entity.Player;
import java.util.List;
import java.util.regex.Pattern;
import org.bukkit.ChatColor;
import java.util.Random;

public class Utils
{
    public static final Random random;
    private static final ChatColor[] goodColors;
    private static final Pattern HEX_PATTERN;
    
    public static ChatColor getGoodColor() {
        return Utils.goodColors[Utils.random.nextInt(Utils.goodColors.length)];
    }
    
    public static List<Player> getOnlinePlayers() {
        final ArrayList<Object> arrayList = Lists.newArrayList();
        final Iterator iterator = Bukkit.getWorlds().iterator();
        while (iterator.hasNext()) {
            arrayList.addAll(((World)iterator.next()).getPlayers());
        }
        return Collections.unmodifiableList((List<? extends Player>)arrayList);
    }
    
    public static ArrayList<Player> getPlayers(final Collection<String> collection) {
        final ArrayList list = new ArrayList();
        final Iterator<String> iterator = collection.iterator();
        while (iterator.hasNext()) {
            final Player player = Bukkit.getPlayer((String)iterator.next());
            if (player != null) {
                list.add(player);
            }
        }
        return list;
    }
    
    public static boolean isNumber(final String s) {
        try {
            Integer.parseInt(s);
            return true;
        }
        catch (final NumberFormatException ex) {
            return false;
        }
    }
    
    public static List<Location> getCircle(final Location location, final Integer n, final Integer n2, final Boolean b, final Boolean b2, final int n3) {
        final ArrayList list = new ArrayList();
        final int blockX = location.getBlockX();
        final int blockY = location.getBlockY();
        final int blockZ = location.getBlockZ();
        for (int i = blockX - n; i <= blockX + n; ++i) {
            for (int j = blockZ - n; j <= blockZ + n; ++j) {
                for (int k = b2 ? (blockY - n) : blockY; k < (b2 ? (blockY + n) : (blockY + n2)); ++k) {
                    final double n4 = (blockX - i) * (blockX - i) + (blockZ - j) * (blockZ - j) + (b2 ? ((blockY - k) * (blockY - k)) : 0);
                    if (n4 < n * n && (!b || n4 >= (n - 1) * (n - 1))) {
                        list.add(new Location(location.getWorld(), (double)i, (double)(k + n3), (double)j));
                    }
                }
            }
        }
        return list;
    }
    
    public static ArrayList<Location> getPlatForm(final Location location) {
        final ArrayList list = new ArrayList();
        list.add(location.clone());
        list.add(location.clone().add(-1.0, 0.0, 0.0));
        list.add(location.clone().add(0.0, 0.0, -1.0));
        list.add(location.clone().add(1.0, 0.0, 0.0));
        list.add(location.clone().add(0.0, 0.0, 1.0));
        list.add(location.clone().add(-1.0, 0.0, -1.0));
        list.add(location.clone().add(1.0, 0.0, -1.0));
        list.add(location.clone().add(1.0, 0.0, 1.0));
        list.add(location.clone().add(-1.0, 0.0, 1.0));
        return list;
    }
    
    public static ArrayList<Location> getRoom(final Location location) {
        final ArrayList list = new ArrayList();
        location.add(0.0, 9.0, 0.0);
        list.addAll(getPlatForm(location));
        for (int i = 0; i < 3; ++i) {
            location.add(0.0, 1.0, 0.0);
            list.add(location.clone().add(0.0, 0.0, -2.0));
            list.add(location.clone().add(0.0, 0.0, 2.0));
            list.add(location.clone().add(2.0, 0.0, 0.0));
            list.add(location.clone().add(-2.0, 0.0, 0.0));
            list.add(location.clone().add(1.0, 0.0, 2.0));
            list.add(location.clone().add(-1.0, 0.0, 2.0));
            list.add(location.clone().add(-2.0, 0.0, 1.0));
            list.add(location.clone().add(-2.0, 0.0, -1.0));
            list.add(location.clone().add(-1.0, 0.0, -2.0));
            list.add(location.clone().add(1.0, 0.0, -2.0));
            list.add(location.clone().add(2.0, 0.0, -1.0));
            list.add(location.clone().add(2.0, 0.0, 1.0));
        }
        list.addAll(getPlatForm(location.add(0.0, 1.0, 0.0)));
        return list;
    }
    
    public static ItemStack getItemStack(final String s, final boolean b, final boolean b2) {
        final String[] split = s.split(" : ");
        final String upperCase = split[0].toUpperCase();
        ItemStackBuilder itemStackBuilder = null;
        if (itemStackBuilder == null) {
            Optional optional = XMaterial.matchXMaterial(upperCase);
            if (!optional.isPresent() && upperCase.contains(":")) {
                optional = XMaterial.matchXMaterial(upperCase.split(":")[0]);
            }
            itemStackBuilder = new ItemStackBuilder(((XMaterial)optional.get()).parseItem());
            if (split[0].contains(":")) {
                final String s2 = upperCase.split(":")[0];
                if ((s2.contains("POTION") || s2.equals("TIPPED_ARROW")) && upperCase.split(":").length == 4) {
                    itemStackBuilder.setPotionEffect(PotionType.valueOf(upperCase.split(":")[1]), Boolean.valueOf(split[0].split(":")[2]), Boolean.valueOf(split[0].split(":")[3]));
                }
                else {
                    itemStackBuilder.setDurability(Integer.parseInt(upperCase.split(":")[1]));
                }
            }
        }
        if (b) {
            itemStackBuilder.setAmount(Integer.parseInt(split[1]));
        }
        if (b2) {
            for (int i = b ? 2 : 1; i < split.length; ++i) {
                final String lowerCase = split[i].split(":")[0].toLowerCase();
                if (lowerCase.equals("name")) {
                    itemStackBuilder.setName(colorize(split[i].split(":")[1]));
                }
                else if (lowerCase.equals("lore")) {
                    itemStackBuilder.addLore(colorize(split[i].split(":")[1]));
                }
                else if (lowerCase.equals("enchant")) {
                    itemStackBuilder.addEnchantment(Enchantment.getByName(split[i].split(":")[1].toUpperCase()), Integer.parseInt(split[i].split(":")[2]));
                }
            }
        }
        return itemStackBuilder.build();
    }
    
    public static int getRandomFromInterval(final int n, final int n2) {
        if (n2 - n > 0) {
            return Utils.random.nextInt(n2 - n + 1) + n;
        }
        return n;
    }
    
    public static void error(final String str) {
        Bukkit.getConsoleSender().sendMessage(ChatColor.RED + "[Hide and Seek] " + str);
    }
    
    public static void playSound(final Player player, final String key) {
        final Sound sound = Config.getInstance().sounds.get(key);
        if (sound == null) {
            return;
        }
        player.playSound(player.getLocation(), sound, 1.0f, 1.0f);
    }
    
    public static boolean compareItem(final ItemStack itemStack, final ItemStack itemStack2) {
        return itemStack != null && itemStack2 != null && itemStack.getType().equals((Object)itemStack2.getType()) && (!itemStack.getItemMeta().hasDisplayName() || itemStack2.getItemMeta().hasDisplayName()) && (itemStack.getItemMeta().hasDisplayName() || !itemStack2.getItemMeta().hasDisplayName()) && (!itemStack.getItemMeta().hasDisplayName() || !itemStack2.getItemMeta().hasDisplayName() || itemStack.getItemMeta().getDisplayName().equals(itemStack2.getItemMeta().getDisplayName())) && (!itemStack.getItemMeta().hasLore() || itemStack2.getItemMeta().hasLore()) && (itemStack.getItemMeta().hasLore() || !itemStack2.getItemMeta().hasLore()) && (!itemStack.getItemMeta().hasLore() || !itemStack2.getItemMeta().hasLore() || itemStack.getItemMeta().getLore().equals(itemStack2.getItemMeta().getLore()));
    }
    
    public static void cageInventory(final Inventory inventory, final boolean b) {
        final ItemStack locked = HideAndSeek.getInstance().locked;
        if (b) {
            for (int i = 0; i < inventory.getSize(); ++i) {
                inventory.setItem(i, locked);
            }
            return;
        }
        for (int j = 0; j < 9; ++j) {
            inventory.setItem(j, locked);
        }
        for (int k = inventory.getSize() - 9; k < inventory.getSize(); ++k) {
            inventory.setItem(k, locked);
        }
        final int n = inventory.getSize() / 9 - 2;
        if (n < 1) {
            return;
        }
        for (int l = 9; l < 9 * n + 1; l += 9) {
            inventory.setItem(l, locked);
        }
        for (int n2 = 17; n2 < 9 * (n + 1); n2 += 9) {
            inventory.setItem(n2, locked);
        }
    }
    
    public static String colorize(String replace) {
        for (Matcher matcher = Utils.HEX_PATTERN.matcher(replace); matcher.find(); matcher = Utils.HEX_PATTERN.matcher(replace)) {
            final String substring = replace.substring(matcher.start(), matcher.end());
            final char[] charArray = substring.replace("&#", "x").toCharArray();
            final StringBuilder sb = new StringBuilder();
            final char[] array = charArray;
            for (int length = array.length, i = 0; i < length; ++i) {
                sb.append("&").append(array[i]);
            }
            replace = replace.replace(substring, sb.toString());
        }
        return ChatColor.translateAlternateColorCodes('&', replace);
    }
    
    static {
        random = new Random();
        goodColors = new ChatColor[] { ChatColor.DARK_AQUA, ChatColor.GOLD, ChatColor.GRAY, ChatColor.BLUE, ChatColor.GREEN, ChatColor.AQUA, ChatColor.RED, ChatColor.LIGHT_PURPLE, ChatColor.YELLOW };
        HEX_PATTERN = Pattern.compile("&#[a-fA-F0-9]{6}");
    }
}
